> For the complete documentation index, see [llms.txt](https://docs.bcbi.brown.edu/codiac-for-health/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.bcbi.brown.edu/codiac-for-health/computing/julia/strings-and-characters.md).

# Strings and Characters

This page provides syntax for strings and characters in Julia as well as some of their associated functions. Each section includes an example to demonstrate the described syntax or function.

## Characters and Strings <a href="#characters_and_strings" id="characters_and_strings"></a>

* `Char` is a single character
* `String` is a sequence of one or more characters (index values start at `1`)

### Some functions that can be performed on strings <a href="#some_functions_that_can_be_performed_on_strings" id="some_functions_that_can_be_performed_on_strings"></a>

| Action                                            | Function                           |
| ------------------------------------------------- | ---------------------------------- |
| get `word` length                                 | `length(word)`                     |
| extract `nth` character from `word`               | `word[n]`                          |
| extract substring `nth-mth` character from `word` | `word[n:m]`                        |
| search for `letter` in `word`                     | `findfirst(isequal(letter), word)` |
| search for `subword` in `word`                    | `occursin(word, subword)`          |
| remove record separator from `word` (e.g., `n`)   | `chomp(word)`                      |
| remove last character from `word`                 | `chop(word)`                       |

Use `typeof()` function to determine type

Input:

```julia
# chars_and_strings.jl

letter = 'b'
word = "good-bye"
subword = "good"

word_length = length(word)
word_first_char = word[1]
word_subword = word[6:8]

println("Length of word: $word_length")
println("First character: $word_first_char")
println("Last three characters: $word_subword")

println("$letter is in $word: $(findfirst(isequal(letter), word))")
println("$subword is in $word: $(occursin(subword, word))")
println("chop off the last character: $(chop(word))")
```

Output:

```julia
Length of word: 8
First character: g
Last three characters: bye
b is in good-bye: 6
good is in good-bye: true
chop off the last character: good-by
```

## Resources <a href="#documentation" id="documentation"></a>

* Julia Documentation: [Manual - Strings](https://docs.julialang.org/en/v1/manual/strings/)
* Julia Documentation: [Base - Strings](https://docs.julialang.org/en/v1/base/strings/)
* Think Julia: [Chapter 8 - Strings](https://benlauwens.github.io/ThinkJulia.jl/latest/book.html#chap08)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.bcbi.brown.edu/codiac-for-health/computing/julia/strings-and-characters.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
